#!/bin/bash

mysqld This shell script takes care of starting and stopping

the MySQL subsystem (mysqld).

chkconfig: 2345 78 36

description: MySQL database server.

processname: mysqld

config: /data/mysql/mysql3306/data/my3306.cnf

pidfile: /data/mysql/mysql3306/data/mysql3306.pid

Source function library.

. /etc/rc.d/init.d/functions

Source networking configuration.

. /etc/sysconfig/network prog="MySQL"

extract value of a MySQL option from config files

Usage: get_mysql_option SECTION VARNAME DEFAULT

result is returned in $result

We use my_print_defaults which prints all options from multiple files,

with the more specific ones later; hence take the last match.

get_mysql_option(){ result=/usr/local/mysql/bin/my_print_defaults --defaults-file=/data/mysql/mysql3306/my.cnf "$1" | sed -n "s/^--$2=//p" | tail -n 1 if [ -z "$result" ]; then # not found, use default result="$3" fi } servername=hostname get_mysql_option mysqld datadir "/data/mysql/mysql3306/data/" datadir="$result" get_mysql_option mysqld socket "/data/mysql/mysql3306/data/mysql.sock" socketfile="$result" get_mysql_option mysqld log-error "/data/mysql/mysql3306/data/error.log" errlogfile="$result" get_mysql_option mysqld pid-file "/data/mysql/mysql3306/data/mysql.pid" mypidfile="$result" start(){ touch "$errlogfile" chown mysql:mysql "$errlogfile" chmod 0640 "$errlogfile" [ -x /sbin/restorecon ] && /sbin/restorecon "$errlogfile" # Pass all the options determined above, to ensure consistent behavior. # In many cases mysqld_safe would arrive at the same conclusions anyway # but we need to be sure. /usr/local/mysql/bin/mysqld_safe --defaults-file=/data/mysql/mysql3306/my.cnf
--user=mysql
>/dev/null 2>&1 & ret=$? # Spin for a maximum of N seconds waiting for the server to come up. # Rather than assuming we know a valid username, accept an "access # denied" response as meaning the server is functioning. if [ $ret -eq 0 ]; then STARTTIMEOUT=30 while [ $STARTTIMEOUT -gt 0 ]; do RESPONSE=/usr/local/mysql/bin/mysqladmin -uroot -proot -P3306 -h127.0.0.1 ping 2>&1 && break echo "$RESPONSE" | grep -q "Access denied for user" && break sleep 1 let STARTTIMEOUT=${STARTTIMEOUT}-1 done if [ $STARTTIMEOUT -eq 0 ]; then echo "Timeout error occurred trying to start MySQL Daemon." action $"Starting $prog: " /bin/false ret=1 else action $"Starting $prog: " /bin/true fi else action $"Starting $prog: " /bin/false fi [ $ret -eq 0 ] && touch /var/lock/subsys/mysqld return $ret } stop(){ MYSQLPID=cat "$mypidfile" 2>/dev/null if [ -n "$MYSQLPID" ]; then /bin/kill "$MYSQLPID" >/dev/null 2>&1 ret=$? if [ $ret -eq 0 ]; then STOPTIMEOUT=60 while [ $STOPTIMEOUT -gt 0 ]; do /bin/kill -0 "$MYSQLPID" >/dev/null 2>&1 || break sleep 1 let STOPTIMEOUT=${STOPTIMEOUT}-1 done if [ $STOPTIMEOUT -eq 0 ]; then echo "Timeout error occurred trying to stop MySQL Daemon." ret=1 action $"Stopping $prog: " /bin/false else rm -f /var/lock/subsys/mysqld rm -f "$socketfile" action $"Stopping $prog: " /bin/true fi else action $"Stopping $prog: " /bin/false fi else ret=1 action $"Stopping $prog: " /bin/false fi return $ret }

restart(){ stop start } condrestart(){ [ -e /var/lock/subsys/mysqld ] && restart || : }

See how we were called.

case "$1" in start) start ;; stop) stop ;; status) status mysqld ;; restart) restart ;; condrestart) condrestart ;; *) echo $"Usage: $0 {start|stop|status|condrestart|restart}" exit 1 esac exit $?